var gChatAlertSettings =
{
    onPreviewAlertAudio : function ()
    {
        var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                                  .getService(Components.interfaces.nsIIOService);
        var nsISoundInst = Components.classes["@mozilla.org/sound;1"]
                                     .createInstance(Components.interfaces.nsISound);

        if (document.getElementById("extensions.gchatalert.useDefaultAlertAudio").value)
            nsISoundInst.play(ioService.newURI(gchatAlertDefaultAlertAudioURI, null, null));
        else
        {
            var alertAudioFilePathPref = document.getElementById("extensions.gchatalert.alertAudioFilePath");
            var localFileInst = Components.classes["@mozilla.org/file/local;1"]
                                          .createInstance(Components.interfaces.nsILocalFile);
            
            localFileInst.initWithPath(alertAudioFilePathPref.value);
            nsISoundInst.play(ioService.newFileURI(localFileInst));
        }
        
        return true;
    },
    
    onBrowseAudioFile : function ()
    {
        const nsIFilePicker = Components.interfaces.nsIFilePicker;
        var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
        var winTitle = "Select Audio file for message alert";
        
        fp.init(window, winTitle, nsIFilePicker.modeOpen);
        fp.appendFilter("Audio Files", "*.wav");
        
        if (fp.show() == nsIFilePicker.returnOK && fp.file) {
          var alertAudioFilePathPref = document.getElementById("extensions.gchatalert.alertAudioFilePath");
          // We change the Pref element value, then the textbox will get synchronized
          alertAudioFilePathPref.value = fp.fileURL.file.path;
          return true;
        }
        
        return false; 
    },
    
    onUseLocalAudioFile : function ()
    {
        var alertAudioFilePathBox = document.getElementById("gca-option-alertAudioFile");
        if (alertAudioFilePathBox.value == "")
            return this.onBrowseAudioFile();
        else
            return true;
    },
};